-- Schema: C6MartPeriodicoImmobiliare
-- Stored Procedure: RP_DM_DETTAGLIO_ASUL







-- =============================================
-- Author:		<Author,,Name>
-- Create date: <Create Date,,>
-- Description:	<Description,,>
-- =============================================
--[C6MartPeriodicoImmobiliare].[TEMP_RP_DM_DETTAGLIO_ASUL]
CREATE PROCEDURE [C6MartPeriodicoImmobiliare].[RP_DM_DETTAGLIO_ASUL]
AS
BEGIN

	SET NOCOUNT ON;

	DECLARE @ID_ELAB INT
	DECLARE @TIPO_ELAB VARCHAR(1)

	SET @ID_ELAB = C6MartPeriodico.GETIDELAB()
	SET @TIPO_ELAB = C6MartPeriodico.GETTIPOELAB()

	-- Log esecuzione
	INSERT INTO LOG_ESECUZIONE_PERIODICO_IMMOBILIARE
		(Nome, Inizio, Nota)
	VALUES (
		'RP_DM_DETTAGLIO_ASUL_1',
		GETDATE(),
		'Mart Immobiliare'
	)
	
    DECLARE @MaxDTTrim AS decimal(9,0)
    SELECT @MaxDTTrim = MAX(DTTRIM) FROM C6STAGINGPERIODICO.WSEIUL
    
	TRUNCATE TABLE C6MartPeriodicoImmobiliare.DETTAGLIO_ASUL
	
	SELECT --********* ATTENZIONE ALLA GESTIONE DEI PRODOTTI ASSICURATIVI SKANDIA
		   --********* DA AGGIUNGERE
		   --********* SI TROVANO CON CONDIZIONE COD_ISIN_SOTTOSTANTE IS NOT NULL
		   --********* ENTRO SUL CATALOGO CON COD_ISIN_SOTTOSTANTE, COD_MAF_SOTTOSTANTE  
		SPB_CONTR_SINTESI.RETE AS RETE,
		SPB_CONTR_SINTESI.CODFIS AS COD_FISCALE,
		--ISNULL(
		--	C6StagingPeriodico.RP_Info_DaProdottoCSaCatalogo(SPB_CONTR_SINTESI.TIPPROD, SPB_ASS_UNIT.CODINT, SPB_ASS_UNIT.MAF, '', SPB_ASS_UNIT.SUBPROD), 
		--	SUBSTRING(SPB_CONTR_SINTESI.POSITIONID, 1, 57)) AS COD_PRODOTTO,
		CAST('' AS VARCHAR(255)) AS COD_PRODOTTO,
		--ISNULL(SUBSTRING(SPB_CONTR_SINTESI.POSITIONID, 1, 57),
  --          C6StagingPeriodico.RP_Info_DaProdottoCSaCatalogo(SPB_CONTR_SINTESI.TIPPROD, SPB_ASS_UNIT.CODINT, SPB_ASS_UNIT.MAF, '', SPB_ASS_UNIT.SUBPROD)
  --            ) AS COD_PRODOTTO,
		SPB_ASS_UNIT.CODCONF AS ID_CONTRATTO,
		SPB_ASS_UNIT.SUBPROD AS COD_SOTTOPRODOTTO,
		SPB_ASS_UNIT.CODINT AS COD_INTERNO,
		SPB_ASS_UNIT.CTV AS CTV,
        CASE
			WHEN ISDATE(SPB_ASS_UNIT.DTRIFE) = 0 THEN NULL
			ELSE CAST(CAST(SPB_ASS_UNIT.DTRIFE AS VARCHAR(8)) AS DATETIME)
		END AS DATA_RIF,
		SPB_ASS_UNIT.ISINFIT AS COD_ISIN_FITTIZIO,
		SPB_ASS_UNIT.ISIN AS COD_ISIN_SOTT,
		SPB_ASS_UNIT.MAF AS COD_MAF_SOTT,
		@ID_ELAB AS ID_ELAB,
		@TIPO_ELAB AS TIPO_ELAB,
		SPB_CONTR_SINTESI.POSITIONID AS SPB_POSITIONID
    INTO #TEMP_DETTAGLIO_ASUL		
	FROM 
		C6StagingPeriodicoImmobiliare.SPB_CONTR_SINTESI 
	INNER JOIN
		C6STAGINGPERIODICO.WSEIUL SPB_ASS_UNIT 
		ON SPB_CONTR_SINTESI.CODCONF = SPB_ASS_UNIT.CODCONF
	LEFT OUTER JOIN
		C6StagingPeriodicoImmobiliare.RP_CatalogoProdotti CATITEMREF 
		ON SPB_ASS_UNIT.CODINT = CATITEMREF.CodInterno
		AND SPB_ASS_UNIT.SUBPROD = CATITEMREF.CodSottoprodotto
		-------------------> Mod del 23/1/2017 - ripristinata and sulla visibilit precedentemente commentata
        AND CATITEMREF.Visibilita = 1 
		-------------------> Fine Mod del 23/1/2017
		AND (SPB_ASS_UNIT.ISIN = '' --and CATITEMREF.CodIsin is null --= '$'
              OR (
			SPB_ASS_UNIT.ISIN = CATITEMREF.CodAdeguatezza
			AND 
			SPB_ASS_UNIT.MAF = CATITEMREF.CodMaf)

		)
WHERE SPB_CONTR_SINTESI.tipprod ='ASUL'
		AND SPB_ASS_UNIT.DTTRIM = @MaxDTTrim
	-------------------> Mod del 23/1/2017 -Commentata and sulla visibilit
	--AND CATITEMREF.Visibilita = 1
	-------------------> Fine Mod del 23/1/2017
    and SPB_CONTR_SINTESI.CTV <> 0
    
    
	-- Log esecuzione
	UPDATE
		LOG_ESECUZIONE_PERIODICO_IMMOBILIARE
	SET
		Fine = GETDATE(),
		Tipo = 'INSERT',
		Righe = @@ROWCOUNT
	WHERE
		Nome = 'RP_DM_DETTAGLIO_ASUL_1' AND
		Inizio = (
			SELECT
				MAX(Inizio)
			FROM
				LOG_ESECUZIONE_PERIODICO_IMMOBILIARE
			WHERE
				Nome = 'RP_DM_DETTAGLIO_ASUL_1'
		)

	-- Log esecuzione
	INSERT INTO LOG_ESECUZIONE_PERIODICO_IMMOBILIARE
		(Nome, Inizio, Nota)
	VALUES (
		'RP_DM_DETTAGLIO_ASUL_2',
		GETDATE(),
		'Mart Immobiliare'
	)

	
	declare @visible int 
	set @visible = 1
	while @visible >= 0
		begin
			UPDATE #TEMP_DETTAGLIO_ASUL
			SET COD_PRODOTTO = C
