-- Schema: C6MartPeriodico
-- Stored Procedure: PL_S76AlternativaPatrimonioNonRappresentabileAssettClass




--exec  [C6MartPeriodico].[PL_S76AlternativaPatrimonioNonRappresentabileAssettClass]   'F' ,'GSPNGL31C04B157Q'

-- =============================================
-- Author:		Luca De Lisio
-- Create date: 04/12/2008
-- Description: <Description,,>
-- =============================================
--
-- [C6MartPeriodico].[PL_S76AlternativaPatrimonioNonRappresentabileAssettClass]  'F', 'BLNMTN60L53L736R'
--
CREATE procedure [C6MartPeriodico].[PL_S76AlternativaPatrimonioNonRappresentabileAssettClass] -- 'S','GLLLCN29H16I829A'
 -- Add the parameters for the stored procedure here
 @Rete char(1), 
 @CodiceFiscale varchar(16)

AS
BEGIN
 -- SET NOCOUNT ON added to prevent extra result sets from
 -- interfering with SELECT statements.

	DECLARE @NOMERETE VARCHAR(20)
	IF @RETE = 'F'
		SET @NOMERETE = 'Fideuram'
	ELSE IF @RETE = 'S'
		SET @NOMERETE = 'Sanpaolo Invest'
		ELSE SET @NOMERETE = 'IW Private Investments'

	SELECT  
		PATRBF.ID_CONTRATTO as Contratto,
		CASE WHEN AREA.NOME_AREA LIKE 'Previdenza%' THEN 'Previdenza' ELSE AREA.NOME_AREA END as Area,
		CASE
		WHEN area.ID_AREA IN ('Pre1', 'Pre2') THEN 'Pre'
		 ELSE area.ID_AREA end as NEEDAREA,
		PATRBF.NOME_PROGETTO as Progetto,
		patrbf.chiave_progetto as ord_progetto,
		dbo.TOSHORTDATESTRING(PATRBF.DATA_SOTTOSCRIZIONE) as DataSottoscrizione,
		ANAGP.DESCR_PRODOTTO AS Descrizione,
		PATRBF.CTV as Controvalore,
		PATRBF.CTV as controvalore_contratto,
		PATRBF.PARTVIA_DISINV as PartitaViaggiante,
		@NOMERETE as Intermediario,
		--patrbf.ordinamento_progetto
		-- savingmap - Novembre 2019
	    patrbf.tipo_prodotto as Tipo_Prodotto,
		NULL as isAPC

	FROM 
		C6MartPeriodico.PATRIMONIO_BF PATRBF
	INNER JOIN
		C6MartPeriodico.AREA_BISOGNO AREA
		ON
			PATRBF.ID_AREA = AREA.ID_AREA
	INNER JOIN 
		C6MartPeriodico.ANAG_PRODOTTI ANAGP
		ON 
			PATRBF.COD_PRODOTTO = ANAGP.COD_PRODOTTO
	LEFT OUTER JOIN 
		C6MartPeriodico.ASSET_PERC ASSETPERC 
		ON 
			PATRBF.COD_PRODOTTO = ASSETPERC.COD_PRODOTTO
			AND ASSETPERC.LIVELLO = 1
	WHERE 1 = 1
		AND PATRBF.RETE = @Rete
		AND PATRBF.COD_FISCALE = @CodiceFiscale
		AND PATRBF.TIPO_PRODOTTO <> 'ASUL'
		AND ASSETPERC.COD_PRODOTTO IS NULL
--INIZIO INTERVENTI OMNIA		
        AND PATRBF.CTV <>0.00
--INIZIO INTERVENTI OMNIA		
--	UNION ALL

--ASUL NO SKANDIA
--	SELECT  
--		PATRBF.ID_CONTRATTO as Contratto,
--		CASE WHEN AREA.NOME_AREA LIKE 'Previdenza%' THEN 'Previdenza' ELSE AREA.NOME_AREA END as Area,
--		CASE
--		WHEN area.ID_AREA IN ('Pre1', 'Pre2') THEN 'Pre'
--		 ELSE area.ID_AREA end as NEEDAREA,
--		PATRBF.NOME_PROGETTO as Progetto,
--		dbo.TOSHORTDATESTRING(PATRBF.DATA_SOTTOSCRIZIONE) as DataSottoscrizione,
--		ANAGP.DESCR_PRODOTTO AS Descrizione,
--		sum(ASUL.CTV) as Controvalore,
--		sum(ASUL.CTV) as controvalore_contratto,
--		Max(PATRBF.PARTVIA_DISINV) as PartitaViaggiante,
--		@NOMERETE as Intermediario
--	FROM
--		C6MartPeriodico.PATRIMONIO_BF PATRBF
--	INNER JOIN
--		C6MartPeriodico.AREA_BISOGNO AREA
--		ON
--			PATRBF.ID_AREA = AREA.ID_AREA
--	INNER JOIN 
--		C6MartPeriodico.ANAG_PRODOTTI ANAGP
--		ON 
--			PATRBF.COD_PRODOTTO = ANAGP.COD_PRODOTTO
--	INNER JOIN 
--		C6MartPeriodico.DETTAGLIO_ASUL ASUL
--		ON 
--			PATRBF.RETE = ASUL.RETE
--			AND PATRBF.COD_FISCALE = ASUL.COD_FISCALE
--			AND PATRBF.ID_CONTRATTO = ASUL.ID_CONTRATTO
--	
--		------ NEW
--		LEFT OUTER JOIN 
--			C6MartPeriodico.ASSET_PERC ASSETPERC
--		ON	
--			ASSETPERC.COD_PRODOTTO = rtrim(ASUL.COD_PRODOTTO)
--			AND ASUL.COD_ISIN_SOTT = ''
--			AND ASSETPERC.LIVELLO = 1


	-------------OLD
	----LEFT OUTER JOIN 
	----		C6MartPeriodico.ASSET_PERC ASSETPERC
	----		ON 
	----			ASSETPERC.COD_PRODOTTO = ASUL.COD_PRODOTTO
	----			AND ASSETPERC.LIVELLO = 1 
--	WHERE 1 = 1
--		AND PATRBF.RETE = @Rete
--		AND PATRBF.COD_FISCALE = @CodiceFiscale
--		AND PATRBF.TIPO_PRODOTTO = 'ASUL'
--		AND ASSETPERC.COD_PRODOTTO IS NULL
--
--
--    GROUP BY 
--     PATRBF.ID
