-- Schema: C6MartPeriodico
-- Stored Procedure: RP_DM_CONTRATTOSEI_pre_selective








CREATE procedure [C6MartPeriodico].[RP_DM_CONTRATTOSEI_pre_selective]
AS

-- Log esecuzione
	INSERT INTO LOG_ESECUZIONE
		(Nome, Inizio, Nota)
	VALUES (
		'RP_DM_CONTRATTOSEI_pre_selective',
		GETDATE(),
		'Elaborazione trimestrale'
	)


TRUNCATE TABLE C6MartPERIODICO.CONTRATTOSEI
INSERT INTO C6MartPERIODICO.CONTRATTOSEI
SELECT     
	[Rete],
	[Cod_Fiscale],
	[PIva_Fiduciaria],
	[DATA_INZIOAVANZATO] as [Data_Sott],
	[CodiceContratto],
	[Cod_Agente],
	[Data_Perf_Base],
	[Data_Perf],
	null as [Fascia_CPP],
	null as [Email],
	[Indirizzo],
	[CAP],
	[Citta],
	[Provincia],
	[Nazione],
	[Presso],
	null as[Data_Inizio],
	[Freq_Diagnosi],
	[FREQ_MONITORAGGIO],
	null as [Freq_DiagnosiPrec],
	null as [Freq_MonitorPrec],
	null as [Data_InizioConsInv],
	[Data_InizioBase],
	[Data_FineBase],
	[DATA_INZIOAVANZATO],
	[Data_FineAvanzato],
	null as [ProgressivoInvio],
	'N',
	'N',
	null as [DataUltimoInvio],
	[ClienteMigrato],
	[RisorseNA],
	null as [PartViaDisinv],
	[NumSolleciti],
	[Data_UltimoSollecito],
	[NumRevoche],
	[Data_UltimaRevoca],
	null as [Note],
	null as [Data_Invio_Diagnosi_Trimestrale],
	null as [Data_Invio_Monitoraggio_Trimestrale],
	[ProfiloAttivo],
	null as [Rol],
	[TIP_CONTRATTO],
	[TIP_RIATTIVAZIONE]

FROM 
    [C6MartPeriodico].[RP_vContrattiPerGenerazioneReport]


	-- Log esecuzione
	UPDATE
		LOG_ESECUZIONE
	SET
		Fine = GETDATE(),
		Tipo = 'INSERT',
		Righe = @@ROWCOUNT
	WHERE
		Nome = 'RP_DM_CONTRATTOSEI_pre_selective' AND
		Inizio = (
			SELECT
				MAX(Inizio)
			FROM
				LOG_ESECUZIONE
			WHERE
				Nome = 'RP_DM_CONTRATTOSEI_pre_selective'
		)
		
		
		
UPDATE c6martperiodico.contrattosei
	set  
		 indirizzo	       = a.indirizzo
		,cap		       = a.cap	
		,citta		       = a.citta
		,prov		       = a.Provincia
		,nazione	       = a.Nazione
		,presso		       = a.Presso
		,Cod_Agente        = a.Cod_Agente
		,Freq_Diagnosi     = a.Freq_Diagnosi
	    ,FREQ_MONITOR      = a.FREQ_MONITORAGGIO
from c6mart.vcontratti a
inner join c6martperiodico.contrattosei b
on a.codicecontratto = b.codicecontratto


UPDATE C6StagingPeriodico.appo_contratti
	set  
		 indirizzo	       = a.indirizzo
		,cap		       = a.cap	
		,citta		       = a.citta
		,provincia	       = a.Prov
		,nazione	       = a.Nazione
		,presso		       = a.Presso
		,Cod_Agente        = a.Cod_Agente
		,Freq_Diagnosi     = a.Freq_Diagnosi
	    ,FREQ_MONITORAGGIO = a.FREQ_MONITOR
from c6martperiodico.contrattosei a
inner join c6stagingperiodico.appo_contratti b
on a.codicecontratto = b.codicecontratto


--INIZIO INTERVENTO TEMPORANEO
--ELIMINARE LE SUCCESSIVE DUE UPDATE DOPO LA TRIMESTRALE DI LUGLIO 2015

--UPDATE c6martperiodico.contrattosei
--	set  
--		 indirizzo	       = a.bindirizzo
--		,cap		       = a.bcap	
--		,citta		       = a.bcitta
--		,prov		       = a.bProvincia
--		,presso		       = a.bPresso
--from cambio_tot a
--inner join c6martperiodico.contrattosei b
--on a.codicecontratto = b.codicecontratto


--UPDATE C6StagingPeriodico.appo_contratti
--	set  
--		 indirizzo	       = a.bindirizzo
--		,cap		       = a.bcap	
--		,citta		       = a.bcitta
--		,provincia	       = a.bProvincia
--		,presso		       = a.bPresso
--from cambio_tot a
--inner join C6StagingPeriodico.appo_contratti b
--on a.codicecontratto = b.codicecontratto
--FINE INTERVENTO TEMPORANEO


-- Allineamento Flag Rol su contratto sei

Update C6MartPeriodico.ContrattoSei
Set Rol = Case D.statorol
		  When 'S' then D.statorol
		  Else 'N'
		  End,
    EmAil = Case d.alertrol
		  When 'S' then D.Email
		  End		 	  
from  C6MartPeriodico.ContrattoSei C inner join  C6StagingPeriodico.datiRol2 D
on d.codContratto = c.codiceContratto


----INIZIO INTERVENTO TEMPORANEO
---- Aggiornamento rol per 59 fiduciare FScirocco _VERIFICARE POST TRIM SE L'INTERVENTO DEVE RIMANERE A REGIME O MENO (chiedere ogni trimestrale)
--UPDATE C6MARTPERIODICO.CONT
