-- Schema: C6MartPeriodico
-- Stored Procedure: RP_DM_GestioneEmail

--delete from C6MartPeriodico.gestione_Email where data_Generazione > getDate()-1
--truncate table log_esecuzione
--select * from log_esecuzione
CREATE PROCEDURE [C6MartPeriodico].[RP_DM_GestioneEmail] 
AS
BEGIN

BEGIN TRANSACTION
--QUESTA SP POPOLA LA TABELLA GESTIONE_EMAIL PER LE CASISTICHE DI:
--	PERFEZIONAMENTO;
--	MANCATA MIGRAZIONE;
--	REINVIO SOLLECITO MANCATA MIGRAZIONE.

--LA GESTIONE DELLE EMAIL PER LE RISORSE NON ASSOCIATE AD AREE DI BISOGNO O
--PER REINVIO DEL SOLLECITO PER LE RISORSE NON ASSOCIATE AD AREE DI BISOGNO 
--VIENE FATTA DOPO L'ALLINEAMENTO CON I DATI DEL SIMPB

	
--ESTRAZIONE EMAIL PERFEZIONAMENTO
--TIPO EMAIL: "PERF"
--L'EMAIL VIENE INVIATA PER TUTTI I CLIENTI CHE HANNO DATA DI PERFEZIONAMENTO VALORIZZATA
--IL CONTROLLO SULLA DATA DI GENERAZIONE >= DELLA DATA DI PERFEZIONAMENTO E' DOVUTO AL
--FATTO CHE IL CONTRATTO PUO` ESSERE CHIUSO E RIAPERTO ED IN QUESTO CASO LA MAIL DI PERFEZIONAMENTO
--DEVE ESSERE REINVIATA

-- EMAIL DI ADESIONE AL SERVIZIO SEI
-- TIPO EMAIL 'PERF'
DECLARE @NUMGIORNIDALPERF SMALLINT
DECLARE @NUMGIORNIDASOLLECITO SMALLINT
DECLARE @ID_ELAB INT
DECLARE @MaxInvioSoll as SMALLINT

SET @MaxInvioSoll = CAST(dbo.getParametro('MaxInvioSoll') as smallint)
SET @ID_ELAB = C6MartPeriodico.GETIDELAB()
SET @NUMGIORNIDALPERF = CAST(dbo.getParametro('NUMGIORNIDALPERF') as smallint) --7
SET @NUMGIORNIDASOLLECITO = CAST(dbo.getParametro('NUMGIORNIDASOLLECITO') as smallint) --7

-- Log esecuzione
INSERT INTO LOG_ESECUZIONE(Nome, Inizio, Nota) 
	VALUES ('RP_DM_GestioneEmail - Mail Perf',GETDATE(),'Elaborazione giornaliera')
--0. MODIFICO I RECORD IN GESTIONE EMAIL CON TIPO = PERF PER EVITARE IL REINVIO MULTIPLO A SEGUITO DELLA RIATTIVAZIONE 
UPDATE C6MartPeriodico.GESTIONE_EMAIL
SET TIPO = 'OLD'
FROM C6MartPeriodico.Gestione_EMAIL EMAIL
	INNER JOIN C6MartPeriodico.VCONTRATTI VC
	   ON VC.COD_FISCALE = EMAIL.COD_FISCALE
	   AND VC.rete = EMAIL.RETE
	   AND EMAIL.TIPO = 'PERF'
    INNER JOIN [C6MartPeriodico].[CONTRATTOSEI_METADATI]  MC
       ON VC.chiaveClientePB = MC.CHIAVECLIENTEPB
       AND VC.riattivazione = 1 AND VC.DATA_FINEAVANZATO = '9999-12-31 00:00:00.000' 
       AND MC.Tip_riattivazione = 1


--1. INSERIMENTO MAIL DI "PERFEZIONAMENTO"
-- TUPLE DA PERFEZIONARE SU CONTRATTOSEI
-- NON PRESENTI SU GESTIONE_EMAIL

INSERT INTO C6MartPeriodico.GESTIONE_EMAIL
	(Rete,Cod_Fiscale,Tipo,Data_Generazione, ID_ELAB)
SELECT 
	VC.Rete,
	VC.Cod_Fiscale,
	'PERF' as TipoEmail,
	GETDATE() AS DataGenerazione,
	@ID_ELAB AS ID_ELAB
FROM C6MartPeriodico.VCONTRATTI VC
INNER JOIN C6MartPeriodico.CONTRATTOSEI_METADATI MD
		ON MD.ChiaveClientePb = VC.ChiaveClientePb
LEFT JOIN C6MartPeriodico.GESTIONE_EMAIL EMAIL
	ON VC.RETE = EMAIL.RETE
	AND VC.COD_FISCALE = EMAIL.COD_FISCALE
	AND EMAIL.TIPO = 'PERF'						
	AND EMAIL.Data_Generazione >= VC.Data_Perf	-- CONDIZIONE PER ESCLUDERE DAL JOIN UN CONTRATTO CHIUSO E RIAPERTO.
LEFT JOIN C6MartPeriodico.CODICI_PROMOTORI_FITTIZI PF	-- IN QUESTO MODO LO INSERIAMO NUOVAMENTE IN GESTIONE_MAIL.
	ON VC.COD_AGENTE BETWEEN PF.CODICEDA AND PF.CODICEA
	AND VC.RETE = PF.RETE
WHERE 1 = 1
	--AND VC.InvioBenvenuto = 'N'
	AND VC.Data_FineAvanzato > getDate()
	--AND VC.GenerazioneReport = 'S'
	AND EMAIL.COD_FISCALE IS NULL
	AND PF.RETE IS NULL
	
		
-- Log esecuzione
UPDATE LOG_ESECUZIONE
SET	Fine = GETDATE(),Tipo = 'INSERT',Righe = @@ROWCOUNT
WHERE Nome = 'RP_DM_GestioneEmail - Mail Perf' AND
	Inizio = (SELECT MAX(Inizio) FROM LOG_ESECUZIONE WHERE Nome = 'RP_DM_GestioneEmail - Mail Perf')

INSERT INTO LOG_ESECUZIONE (Nome, Inizio, Nota)
	VALUES ('RP_DM_GestioneEmail - SollecitiNOMIG',GETDATE(),'Elaborazione giornaliera')

-- 2. INSERIMENTO MAIL "SOLLECITI"
-- TUPLE DA PERFEZIONARE SU CONTRATTOSEI
-- E PRESENTI SU GESTIONE_EMAIL
-- IL PB NON HA EFFETTUATO LA MIGRAZIONE
-- N.B. PER IL PRIMO SOLLECITO DATA_ULTIMOSOLLECITO  NULL -> CONSIDERIAMO DATA_PERF

INSERT INTO C6MartPeriodico.GESTIONE_EMAIL

