-- Schema: C6MartPeriodico
-- Stored Procedure: RP_DM_MONITORAGGIO_DETTAGLIO









  
-- =============================================  
-- Author:  Rino Le Boffe  
-- Create date: 16 luglio 2013  
-- Description:   
--Aggiunta GESTIONE EligoTitoli L192 (FCianfa, 26/11/2014)  
-- =============================================  
CREATE   procedure [C6MartPeriodico].[RP_DM_MONITORAGGIO_DETTAGLIO]  
AS  
BEGIN  
  
 SET NOCOUNT ON;  
  
 DECLARE @ID_ELAB INT  
  
 SET @ID_ELAB = [C6MartPeriodico].GETIDELAB()  
  
 -- Log esecuzione  
 INSERT INTO LOG_ESECUZIONE_PERIODICO  
  (Nome, Inizio, Nota)  
 VALUES (  
  'RP_DM_MONITORAGGIO_DETTAGLIO',  
  GETDATE(),  
  'Elaborazione trimestrale'  
 )  
  
 TRUNCATE TABLE [C6MartPeriodico].[MONITORAGGIO_DETTAGLIO]   
    
-- begin try  
  
 INSERT INTO [C6MartPeriodico].[MONITORAGGIO_DETTAGLIO]  
           ([RETE]  
           ,[COD_FISCALE]  
           ,[POSITION_ID]  
           ,[ID_AREA]  
           ,[DATA_ASSOCIAZIONE]  
           ,[VERSATO_NETTO_DA_ASSOC]  
           ,[UTILE_PERDITA_DA_ASSOC]  
           ,[ID_ELAB])  
  
 SELECT  distinct -- aggiunta distinct 20231212 per duplicati
   B.RETE,  
   B.CODFIS,  
   B.POSITIONID,  
   A.[ID_AREA],  
   CASE WHEN A.TIPPROD='CC' and data_associazione < '20110211'   
                THEN cast('20110211' AS DATETIME)  
   ELSE DATA_ASSOCIAZIONE END AS DATA_ASSOCIAZIONE,  
   A.CVNNAC AS [VERSATO_NETTO_DA_ASSOC],  
   CASE WHEN A.CVNNAC =0 THEN 0 ELSE (B.CTV - A.CVNNAC) END AS [UTILE_PERDITA_DA_ASSOC],  
   @ID_ELAB AS [ID_ELAB]  
   FROM  
   C6STAGINGPERIODICO.SPB_CONTR_SINTESI B  
   INNER JOIN  
   (  
            SELECT  
            TCP.RETE AS  [RETE],  
   VC.COD_FISCALE AS [COD_FISCALE],  
      TCP.CODPROD,  
      TCP.TIPPROD,   
      TCP.CODINT,   
      TCP.MAF,  
      TCP.ISIN,  
      TCP.SUBPROD,   
      TCP.CODCONF,   
      TCP.NUMPOL,   
      TCP.CONTO,   
      TCP.RUBR,   
      TCP.CUSTGAR,  
      TCP.TERMID,   
      TCP.ANNO,   
      TCP.PROG,  
               TCP.CODPROG,  
   CASE   
            WHEN TCP.CODAREA='EXR' THEN 'EXT' ELSE TCP.CODAREA   
            END AS ID_AREA,  
   CASE WHEN TCP.DTINGRESSO=0 THEN   
     (CASE WHEN TCP.DTININAC=0 THEN NULL ELSE cast(CAST(TCP.DTININAC AS VARCHAR(8)) as datetime)END)  
   ELSE cast(CAST(TCP.DTINGRESSO AS VARCHAR(8)) as datetime)  
            --ELSE CAST(DTININAC AS DATETIME)    
            END AS [DATA_ASSOCIAZIONE],  
   TCP.CVNNAC  
   FROM  
            C6STAGINGPERIODICO.TANAB ANA   
            JOIN   
   C6STAGINGPERIODICO.TCPTAB TCP  
            ON ANA.CODAREA=TCP.CODAREA  
            AND ANA.RETE=TCP.RETE  
            AND ANA.CODPROG=TCP.CODPROG  
            AND ANA.CODFIS=TCP.CODFIS  
            INNER JOIN [C6MartPeriodico].[RP_vContrattiPerGenerazioneReport] VC  
                        ON ANA.CODFIS = CASE WHEN VC.COD_MANDATO IS NULL OR VC.COD_MANDATO = ''   
                              THEN CASE WHEN VC.PIVA_FIDUCIARIA IS NULL OR VC.PIVA_FIDUCIARIA = ''   
                                    THEN VC.COD_FISCALE   
                             ELSE VC.PIVA_FIDUCIARIA END   
                             ELSE VC.COD_MANDATO  
                          END  
               AND ANA.RETE = VC.RETE  
--               AND VC.DATA_FINEAVANZATO > getDate()   
            WHERE DTVALORIZ NOT IN (99991231) AND   
                  DTUSCITA=99991231) A  
   ON   
    A.COD_FISCALE=B.CODFIS  
   AND B.RETE=B.RETE  
   AND A.CODPROD=B.CODPROD  
   AND A.CODCONF=B.CODCONF  
   AND A.CODINT=B.CODINT  
   AND A.SUBPROD=B.SUBPROD  
   AND A.NUMPOL=B.NUMPOL  
   AND A.CONTO=B.CONTO  
   AND (case when a.TIPPROD='CC' and (a.rubr is null OR LTRIM(RTRIM(a.rubr)) = '') then '000' else a.rubr end)=B.RUBR  
            AND (  CASE  
     WHEN PCTKEY IS NULL OR PCTKEY = '' OR LTRIM(RTRIM(PARSENAME(REPLACE(PCTKEY, '/', '.'), 1))) = '' THEN 0  
     ELSE CAST(PARSENAME(REPLACE(PCTKEY, '/', '.'), 1) AS decimal(9, 0)) END 
