-- Schema: C6Mart
-- Stored Procedure: GESTIONE_SELECT_EMAIL_DA_INVIARE_CU




  
CREATE procedure [C6Mart].[GESTIONE_SELECT_EMAIL_DA_INVIARE_CU]
AS


BEGIN
	 
execute [C6Mart].[RP_DM_CheckEmail]

--recupero la percentuale limite di risorse non associate
DECLARE @RNA varchar(3)
select @RNA= dbo.getParametro('PERCMAXRISORSENA') + '%'
DECLARE @Ambiente varchar(20)
select @Ambiente= dbo.getParametro('Ambiente')
DECLARE @DestinatarioEmail varchar(255)
select @DestinatarioEmail= dbo.getParametro('DestinatarioEmail')


TRUNCATE TABLE c6mart.test_Quality_Email

INSERT INTO c6mart.test_Quality_Email
SELECT
data_perf, 
dateadd(
	day,(
		(CAST(dbo.getParametro('MaxInvioSoll') as smallint)-1) * 
		 CAST(dbo.getParametro('NUMGIORNIDASOLLECITO') as smallint)+
		 CAST(dbo.getParametro('NUMGIORNIDALPERF') as smallint)),
	 	 data_perf) as DATA_PERF_REV
		,CONTRATTOSEI.rete
		,CONTRATTOSEI.cod_agente
		,CM.numSolleciti
		,GESTIONE_EMAIL.TIPO
		,GESTIONE_EMAIL.[Email_Id]
		,CONTRATTOSEI.Cod_Fiscale
   	,[dbo].[Replace_From_Email](GESTIONE_EMAIL.[Rete],ISNULL(TIPO_EMAIL.[E_From],'')) E_From
		,
		case 
			when 
			
			@Ambiente = 'Produzione' 
			
			then 
				dbo.Replace_To_Email(TIPO_EMAIL.[E_To],ANAG_PROMOTORI.E_MAIL,'','')
			else
				@DestinatarioEmail
		 end 
		 as [E_To]
		,
		case
			when 
				GESTIONE_EMAIL.Tipo <> 'PERF' 
				
			then
				dbo.getParametro('Destinatario_Bcc')
			else
				''
		end  as E_Ccn
		, case 
			when 
				@Ambiente = 'Produzione' 
				
			then 
				dbo.Cc_Email(CONTRATTOSEI.rete,CONTRATTOSEI.cod_agente,CM.numSolleciti,GESTIONE_EMAIL.TIPO)
			else
				''
		 end as E_Cc
    , case 
			when 
				@Ambiente = 'Produzione' 
				
			then 
				dbo.Replace_Subject_Email_test(TIPO_EMAIL.[E_Subject],ANAG_CLIENTI.NOME,ANAG_CLIENTI.COGNOME,ANAG_PROMOTORI.NOME,ANAG_PROMOTORI.COGNOME,ANAG_PROMOTORI.ID_PROMOTORE, CONTRATTOSEI.tip_contratto)
			else
				dbo.Replace_Subject_Email_test(TIPO_EMAIL.[E_Subject],ANAG_CLIENTI.NOME,ANAG_CLIENTI.COGNOME,ANAG_PROMOTORI.NOME,ANAG_PROMOTORI.COGNOME,ANAG_PROMOTORI.ID_PROMOTORE, CONTRATTOSEI.tip_contratto) + '--- TO:' + dbo.Replace_To_Email(TIPO_EMAIL.[E_To],ANAG_PROMOTORI.E_MAIL,'','') + '--- CC:' + dbo.Cc_Email(CONTRATTOSEI.rete,CONTRATTOSEI.cod_agente,CM.numSolleciti,GESTIONE_EMAIL.TIPO) + '---'
		 end as E_Subject
    , case
			when
				len(ltrim(rtrim(GESTIONE_EMAIL.[Cod_Fiscale]))) = 11
			then
				--persone giuridiche
				dbo.Replace_Testo_Email_test(CONTRATTOSEI.CodiceContratto,GESTIONE_EMAIL.[Cod_Fiscale],isnull(ANAG_CLIENTI.Nome,' '),isnull(ANAG_CLIENTI.Cognome,'/$COGNOME NON PRESENTE$/'),ANAG_PROMOTORI.ID_PROMOTORE,ANAG_PROMOTORI.Cognome,ANAG_PROMOTORI.Nome,CONTRATTOSEI.Data_Perf,CONTRATTOSEI.Freq_Diagnosi,CONTRATTOSEI.Freq_Monitoraggio,@RNA, CONTRATTOSEI.tip_contratto,CONTRATTOSEI.DATA_FINEAVANZATO, CONTRATTOSEI.DATA_INZIOAVANZATO,CONTRATTOSEI.RETE,TIPO_EMAIL.[Testo])
			else
				--persone fisiche
				dbo.Replace_Testo_Email_test(CONTRATTOSEI.CodiceContratto,GESTIONE_EMAIL.[Cod_Fiscale],isnull(ANAG_CLIENTI.Cognome,'/$COGNOME NON PRESENTE$/'),isnull(ANAG_CLIENTI.Nome,' '),ANAG_PROMOTORI.ID_PROMOTORE,ANAG_PROMOTORI.Cognome,ANAG_PROMOTORI.Nome,CONTRATTOSEI.Data_Perf,CONTRATTOSEI.Freq_Diagnosi,CONTRATTOSEI.Freq_Monitoraggio,@RNA, CONTRATTOSEI.tip_contratto,CONTRATTOSEI.DATA_FINEAVANZATO, CONTRATTOSEI.DATA_INZIOAVANZATO,CONTRATTOSEI.RETE,TIPO_EMAIL.[Testo])
		 end as Testo
--into c6mart.test_Quality_Email
FROM [C6Mart].[GESTIONE_EMAIL] GESTIONE_EMAIL
 INNER JOIN [C6Mart].[TIPO_EMAIL] TIPO_EMAIL
 ON GESTIONE_EMAIL.Tipo = TIPO_EMAIL.Tipo
 INNER JOIN [C6Mart].[VCONTRATTI] CONTRATTOSEI
 ON CONTRATTOSEI.Rete = GESTIONE_EMAIL.[Rete]
 AND CONTRATTOSEI.Cod_Fiscale = GESTIONE_EMAIL.Cod_Fiscale
 AND CONTRATTOSEI.data_fineavanzato > getDate()
 INNER JOIN [C6Mart].[CONTRATTOSEI_METADATI] CM
 ON CONTRATTOSEI.Rete = GESTIONE_EMAIL.[Rete]
 AND CONTRATTOSEI.CHIAVECLIENTEPB = CM.CHIAVECLIENTEPB
 LEFT JOIN [C6Mart].[ANAG_CLIENTI] ANAG_CLIENTI
 ON ANAG_CLIENTI.Rete = GESTIONE_EMAI
