-- Schema: C6Mart
-- Stored Procedure: RP_DM_ESG_ANAG_METRICHE









-- =============================================
-- Author:		<Author,,Name>
-- Create date: <Create Date,,>
-- Description:	<Description,,>
-- =============================================
--select * from c6mart.assetclass
CREATE    procedure [C6Mart].[RP_DM_ESG_ANAG_METRICHE]
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

	DECLARE @ID_ELAB INT
	DECLARE @TIPO_ELAB VARCHAR(1)
	
	SET @ID_ELAB = C6MART.GETIDELAB()
	SET @TIPO_ELAB = C6MART.GETTIPOELAB()

	-- Log esecuzione
	INSERT INTO LOG_ESECUZIONE
		(Nome, Inizio, Nota)
	VALUES (
		'RP_DM_ESG_ANAG_METRICHE',
		GETDATE(),
		'Elaborazione giornaliera'
	)

TRUNCATE TABLE  C6STAGING.ESG_ANAG_METRICHE  
   
 INSERT INTO [C6STAGING].ESG_ANAG_METRICHE  
     ( [COD_PRODOTTO]
      ,[CodSottoprodotto]
      ,[CodInterno]
      ,[CodMaf]
      ,[CodAdeguatezza]
      ,[CodIsin]
      ,[ESG_E]
      ,[ESG_S]
      ,[ESG_G]
      ,[CatSFDR]
      ,[ESGRating]
      ,[TrendESGRating]
	   ,[LABEL_Green_Bond]
      ,[LABEL_Social_Bond]
      ,[LABEL_Sustainability_Bond]
      ,[LABEL_Transition_Bond]
      ,[LABEL_Sust_linked_bond]
	  ,LABEL_EU_GREEN_BOND_STANDARD
	  ,[PERC_INVESTIMENTO_TAXONOMY]
      ,[PERC_INVESTIMENTO_SFDR]
	  ,[PERC_INVEST_SFDR_MIN_SUST_E]
	  ,[PERC_INVEST_SFDR_MIN_SUST_S]
	  ,[PAI_LAB_A_Emissioni_Gas_Serra]
      ,[PAI_LAB_A_Biodiversita]
      ,[PAI_LAB_A_Acqua]
      ,[PAI_LAB_A_Rifiuti]
      ,[PAI_LAB_A_Gov_Ambientale]
      ,[PAI_LAB_A_Comb_Fossili]
      ,[PAI_LAB_A_Eff_energetica]
      ,[PAI_LAB_S_Questioni_Soc_Dip]
      ,[PAI_LAB_S_Gov_Sociali]
      ,[U_INFO_ESG]
     ,[ID_ELAB]
      ,[TIPO_ELAB]
      )  
 SELECT   
  --ChiaveProdotto,   
  CatalogueID AS COD_PRODOTTO,  
  C.CodSottoprodotto AS COD_SOTTOPRODOTTO, 
  ISNULL(C.CodInterno, '') AS COD_INTERNO, 
  C.CodMaf AS COD_MAF, 
  C.CodAdeguatezza AS COD_ADEGUATEZZA,  
  ISNULL(C.CodIsin, '') AS COD_ISIN,  
  case when Ltrim(rtrim(ESG_E)) = 'Y' then 'SI' 
  when Ltrim(rtrim(ESG_E)) = 'N' then 'NO'
  else 'NO' end  as ESG_E,
  case when Ltrim(rtrim(ESG_S)) = 'Y' then 'SI' 
  when Ltrim(rtrim(ESG_S)) = 'N' then 'NO'
  else 'NO' end  as ESG_S,
  case when Ltrim(rtrim(ESG_G)) = 'Y' then 'SI' 
  when Ltrim(rtrim(ESG_G)) = 'N' then 'NO'
  else 'NO' end  as ESG_G,
  case when CatSFDR='-' then '' else substring(CatSFDR,1,5) +' SFDR' end as CatSFDR, 	
  Ltrim(rtrim(ESGRating)) as ESGRating ,
  Ltrim(rtrim(TrendESGRating)) as TrendESGRating,
  case when LABEL_Green_Bond<> '-' then 'Green Bond' else '' end as LABEL_Green_Bond,
  case when LABEL_Social_Bond<> '-' then 'Social Bond' else '' end as LABEL_Social_Bond,
  case when LABEL_Sustainability_Bond<> '-' then 'Sustainability Bond' else '' end as LABEL_Sustainability_Bond,
  case when LABEL_Transition_Bond<> '-' then 'Transition Bond' else '' end as LABEL_Transition_Bond,
  case when LABEL_Sust_linked_bond<> '-' then 'Sustainability Linked Bond' else '' end as LABEL_Sust_linked_bond,
  case when LABEL_EU_GREEN_BOND_STANDARD<> '-' then 'EU Green Bond Standard' else '' end as LABEL_EU_GREEN_BOND_STANDARD,
  PERC_INVESTIMENTO_TAXONOMY *100 as PERC_INVESTIMENTO_TAXONOMY,
  PERC_INVESTIMENTO_SFDR * 100 as PERC_INVESTIMENTO_SFDR,
  [PERC_INVEST_SFDR_MIN_SUST_E] * 100 as PERC_INVEST_SFDR_MIN_SUST_E ,
  [PERC_INVEST_SFDR_MIN_SUST_S]  * 100 as PERC_INVEST_SFDR_MIN_SUST_S,
  case when PAI_LAB_A_Emissioni_Gas_Serra<>'-' then 'Emissioni Gas Serra' else '' end as PAI_LAB_A_Emissioni_Gas_Serra,
  case when PAI_LAB_A_Biodiversita<>'-' then 'Biodiversit' else '' end as PAI_LAB_A_Biodiversita,
  case when PAI_LAB_A_Acqua<>'-' then 'Acqua' else '' end as PAI_LAB_A_Acqua,
  case when PAI_LAB_A_Rifiuti<>'-' then 'Rifiuti' else '' end as PAI_LAB_A_Rifiuti,
  case when PAI_LAB_A_Gov_Ambientale<>'-' then 'Governativi Ambientali' else '' end as PAI_LAB_A_Gov_Ambientale,
  case when PAI_LAB_A_C
