-- Schema: C6Mart
-- Stored Procedure: SRV_CHECK_C6_GIORNALIERO_20161026_2




CREATE procedure [C6Mart].[SRV_CHECK_C6_GIORNALIERO_20161026_2]
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

	DECLARE @DataOggiPerVar VARCHAR(8)
	SET @DataOggiPerVar = convert(VARCHAR(8), getdate(), 112)

	--V Esegue la procedura di estrazione dei CC
	EXEC [C6Mart].[SRV_ESTRAZ_GIORNALIERA_CC]

	-- Report generati
	SELECT
		C.Rete,
		C.Cod_Agente,
		case when C.Cod_Fiscale  like '%@%' then c.piva_fiduciaria + '  ' + substring(cod_fiscale,4,6) else C.Cod_Fiscale end as Cod_fiscale,
		C.Data_Perf
	INTO #ReportGenerati
	FROM
		C6Mart.GESTIONE_PDF_FTP AS GPF
		INNER JOIN C6Mart.VCONTRATTI AS C             
			ON GPF.RETE = C.Rete
			AND GPF.CODICEFISCALE = C.Cod_Fiscale
        INNER JOIN C6Mart.ContrattoSEI_metadati AS M
            on  C.chiaveclientepb = M.chiaveclientepb
	WHERE
		dbo.toShortDateString(GPF.DataGenerazione) = dbo.toShortDateString(GETDATE())
		AND Data_FineAvanzato > getDate()
	ORDER BY
		C.Rete,
		C.Cod_Agente,
		C.Cod_Fiscale

	-- Report non generati
	SELECT
		Rete,
		Cod_Agente,
		case when Cod_Fiscale  like '%@%' then piva_fiduciaria + '  ' + substring(cod_fiscale,4,6) else Cod_Fiscale end as Cod_fiscale,
		Data_Perf,
		ClienteMigrato,
		RisorseNA,
		profiloAttivo,
		'Ragione:' 
		---------------en 20161026 eliminated NA
		--+ CASE
		--	WHEN ClienteMigrato = 'N' AND RisorseNA = 'S' AND profiloAttivo = 1 AND Data_UltimaRevoca is null THEN ' Cliente non migrato ' --/ Risorse non associate '
		--	ELSE ''
		--END
		--+ CASE
		--	WHEN ClienteMigrato = 'N' AND RisorseNA = 'S' AND profiloAttivo = 1 AND Data_UltimaRevoca is not null THEN ' In attesa di gestione Revoca / Cliente non migrato ' --/ Risorse non associate '
		--	ELSE ''
		--END
		--+ CASE
		--	WHEN ClienteMigrato = 'N' AND RisorseNA = 'S' AND profiloAttivo = 0 AND Data_UltimaRevoca is null THEN ' Cliente non migrato / Profilo non attivo ' --/ Risorse non associate '
		--	ELSE ''
		--END
		--+ CASE
		--	WHEN ClienteMigrato = 'N' AND RisorseNA = 'S' AND profiloAttivo = 0 AND Data_UltimaRevoca is not null THEN ' In attesa di gestione Revoca / Cliente non migrato / Profilo non attivo ' --/ Risorse non associate '
		--	ELSE ''
		--END
		------------------en 20161026
		+ CASE
			WHEN ClienteMigrato = 'N' AND RisorseNA = 'N' AND profiloAttivo = 0 AND Data_UltimaRevoca is null THEN ' Cliente non migrato / Profilo non attivo '
			ELSE ''
		END
		+ CASE
			WHEN ClienteMigrato = 'N' AND RisorseNA = 'N' AND profiloAttivo = 0 AND Data_UltimaRevoca is not null THEN ' In attesa di gestione Revoca / Cliente non migrato / Profilo non attivo '
			ELSE ''
		END
		+ CASE
			WHEN ClienteMigrato = 'N' AND RisorseNA = 'N' AND profiloAttivo = 1 AND Data_UltimaRevoca is null THEN ' Cliente non migrato '
			ELSE ''
		END
		+ CASE
			WHEN ClienteMigrato = 'N' AND RisorseNA = 'N' AND profiloAttivo = 1 AND Data_UltimaRevoca is not null THEN ' In attesa di gestione Revoca / Cliente non migrato '
			ELSE ''
		END
		-------------------en 20161026  eliminated NA
		--+ CASE
		--	WHEN ClienteMigrato = 'S' AND RisorseNA = 'S' AND profiloAttivo = 1 AND Data_UltimaRevoca is null THEN ' Risorse non associate '
		--	ELSE ''
		--END
		--+ CASE
		--	WHEN ClienteMigrato = 'S' AND RisorseNA = 'S' AND profiloAttivo = 1 AND Data_UltimaRevoca is not null THEN ' In attesa di gestione Revoca / Risorse non associate '
		--	ELSE ''
		--END
		--+ CASE
		--	WHEN ClienteMigrato = 'S' AND RisorseNA = 'S' AND profiloAttivo = 0 AND Data_UltimaRevoca is null THEN ' Risorse non associate / Profilo non attivo '
		--	ELSE ''
		--END
		--+ CASE
		--	WHEN ClienteMigrato = 'S' AND RisorseNA = 'S' AND profiloAttivo = 0 AND Data_UltimaRevoca is not null THEN ' In attesa di gestione Revoca / Risorse non associate / Profilo non attivo '
		--	ELSE ''
		--END
		-------------------en 20161026
		+ CASE
			WHEN ClienteMigrato = 'S' AND RisorseNA
