-- Schema: C6Staging
-- Stored Procedure: RP_ST_CatalogoProdotti



CREATE procedure [C6Staging].[RP_ST_CatalogoProdotti]
as

begin 

	-- Log esecuzione
	INSERT INTO LOG_ESECUZIONE
		(Nome, Inizio, Nota)
	VALUES (
		'RP_ST_CatalogoProdotti',
		GETDATE(),
		'Elaborazione giornaliera'
	)
--drop table c6staging.RP_CatalogoProdotti
	truncate table c6staging.RP_CatalogoProdotti

INSERT INTO [C6Staging].[RP_CatalogoProdotti]
           ([ChiaveProdotto]
           ,[CodSottoprodotto]
           ,[CodInterno]
           ,[CodMaf]
           ,[CodAdeguatezza]
           ,[CodIsin]
           ,[TipoVersamento]
           ,[RischioPrSc]
           ,[StatoProdotto]
           ,[TipoPolizza]
           ,[NomeProdotto]
           ,[Visibilita]
           ,[PrezzoInEuro]
           ,[Alberatura]
           ,[DtScadenza]
           ,[Categoria]
           ,[Istituto]
           ,[Piazza]
           ,[PrezzoInValuta]
           ,[PrezzoValuta]
           ,[Codiceadb]
           , [TipoProdotto]
           ,[RatingObbligazioni]
           ,[RischioMinimo]
           ,[CapRisparmio]
           ,[CapMinimo]
           ,[CapMinimoValuta]
           ,[CapMinSucc]
           ,[CapMinSuccValuta]
           ,[MinRispContr]
           ,[MinRispContrValuta]
           ,[SuccRispContr]
           ,[SuccRispContrValuta]
           ,[MinComm]
           ,[MinCommValuta]
           ,[DelegaGestionale]
           ,[TipologiaPerPick]
           ,[RischioPrezzo]
           ,[RegimeFiscale]
           ,[Quotato]
           ,[ClasseDiPrezzo]
           ,[Lineefinacc]
           ,[DurataContrattuale]
           ,[RiscFinFaseAcc]
           ,[OpzRendVital]
           ,[MetaA]
           ,[MetaB]
           ,[MetaC]
           ,[DtRifPrezzo]
           ,[CodTipoContratto]
           ,[PrezzoNetto]
           ,[PrezzoNettoValuta]
           ,[DtPrezzoNetto]
           ,[CodBloomberg]
           ,[DenomUnitLink]
           ,[DtInizioValidita]
           ,[Negoziabilita]
           ,[TassoTecnico]
           ,[TassoTecnicoValuta]
           ,[CollSkandia]
           ,[CodAssetSatellite]
           ,[Mercato]
           ,[AzOb]
           ,[Complessita]
           ,[Emittente]
           ,[GaranziaDemografica]
           ,[SocietaDiGestione]
           ,[IndPrz]
           ,[Differimento]
           ,[DtPrezzo]
           ,[TipoObbligazione]
           ,[TaglioMinimo]
           ,[IsAttivoRc]
           ,[RischioCredito]
           ,[Copertura]
           ,[VarP]
           ,[Diversificazione]
           ,[FlagCoreSatellite]
           ,[PerimetroCoreSatellite]
           ,[FondoCore]
		   ,[DESCR_SGR]
		   ,[Dossier]
		   ,[SottoProdottoSelf])
   	select cat.[ChiaveProdotto]
           ,cat.[CodSottoprodotto]
           ,cat.[CodInterno]
           ,cat.[CodMaf]
           ,cat.[CodAdeguatezza]
           ,cat.[CodIsin]
           ,cat.[TipoVersamento]
           ,cat.[RischioPrSc]
           ,cat.[StatoProdotto]
           ,cat.[TipoPolizza]
           ,cat.[NomeProdotto]
           ,cat.[Visibilita]
           ,cat.[PrezzoInEuro]
           ,cat.[Alberatura]
           ,cat.[DtScadenza]
           ,cat.[Categoria]
           ,cat.[Istituto]
           ,cat.[Piazza]
           ,cat.[PrezzoInValuta]
           ,cat.[PrezzoValuta]
           ,cat.[Codiceadb]
-- INIZIO INTERVENTO MIGRAZIONE ASU3
--         ,[TipoProdotto]
		   ,CASE WHEN cat.[TipoProdotto] = 'ASU3' then 'ASU1' else cat.[TipoProdotto] END as TipoProdotto
-- FINE INTERVENTO MIGRAZIONE ASU3		   
           ,cat.[RatingObbligazioni]
           ,cat.[RischioMinimo]
           ,cat.[CapRisparmio]
           ,cat.[CapMinimo]
           ,cat.[CapMinimoValuta]
           ,cat.[CapMinSucc]
           ,cat.[CapMinSuccValuta]
           ,cat.[MinRispContr]
           ,cat.[MinRispContrValuta]
           ,cat.[SuccRispContr]
           ,cat.[SuccRispContrValuta]
           ,cat.[MinComm]
           ,cat.[MinCommValuta]
           ,cat.[Delega
